' Editeur de niveau pour Fer3 version TI-ASM


DECLARE SUB ClearFile ()
DECLARE SUB Affichage ()
DECLARE SUB SaveFile ()
DECLARE SUB OpenFile ()
DECLARE SUB DefineAsc ()
DECLARE SUB PrintScreen ()

    CONST Maxx = 7
    CONST Maxy = 3
    CONST MaxZ = 17

    CONST TRUE = -1
    CONST FALSE = 0

    DIM SHARED p(Maxx, Maxy, 14, 7) AS STRING * 1
    DIM SHARED t(Maxx, Maxy, 14, 7) AS STRING * 1

    DIM SHARED FileName AS STRING * 10
   
    DIM SHARED Pz(MaxZ) AS INTEGER
    DIM SHARED Tz(MaxZ) AS INTEGER
   
    DIM SHARED m AS INTEGER
    DIM SHARED n AS INTEGER
    DIM SHARED l AS INTEGER
    DIM SHARED i AS INTEGER
    DIM SHARED j AS INTEGER
    DIM SHARED xn AS INTEGER
    DIM SHARED yn AS INTEGER
    DIM SHARED Cla AS STRING * 2

    DIM SHARED xnd AS INTEGER
    DIM SHARED ynd AS INTEGER
    DIM SHARED xd  AS INTEGER
    DIM SHARED yd  AS INTEGER

    DIM SHARED Buf AS STRING
   
    DIM SHARED MaxDessin AS INTEGER
    DIM SHARED MaxTest AS INTEGER
    MaxDessin = 50
    MaxTest = 30
    DIM SHARED Dessin(MaxDessin)  AS STRING * 8
    DIM SHARED Test(MaxTest)      AS STRING * 8

' Dbut du programme

' Lecture des donnes
    RESTORE Graphique
    READ Buf
    k = 0
    WHILE Buf <> "END" AND k < MaxDessin
     Dessin(k) = Buf
     READ Buf
     k = k + 1
    WEND
    MaxDessin = k - 1
    READ Buf
    k = 0
    WHILE Buf <> "END" AND k < MaxTest
     Test(k) = Buf
     READ Buf
     k = k + 1
    WEND
    MaxTest = k - 1
   
    SCREEN 0
   
    CHDIR "c:\ti-92\fargo1\utils\sprite"

    CLS
   
    xnd = 0: ynd = 0: xd = 10: yd = 10

    PRINT "Cration de niveau pour Fer 3 Ti Asm Version"
    INPUT "Nom de fichier:", FileName
    PRINT "Nouveau (1) ou Ouverture (2):"
  
    Buf = ""
    WHILE NOT (Buf = "1" OR Buf = "2")
        Buf = RIGHT$(INKEY$, 1)
    WEND

    IF Buf = "1" THEN
       ClearFile
    ELSE
       OpenFile
    END IF

    OPEN "DATA.DAT" FOR INPUT AS #1
       INPUT #1, x
       IF x = MaxZ THEN
       FOR x = 0 TO MaxZ
        INPUT #1, Pz(x), Tz(x)
       NEXT
       END IF

    CLOSE #1


    Terminated = FALSE

    j = 0: i = 0

    WHILE NOT (Terminated)

        CLS
        xn = -1
        WHILE xn < 0 OR xn > Maxx
                INPUT "Xn:", xn
        WEND
        yn = -1
        WHILE yn < 0 OR yn > Maxy
                INPUT "Yn:", yn
        WEND

        WinTerminated = FALSE
               
        PrintScreen

        WHILE NOT (WinTerminated)
             Affichage
             Buf = INKEY$
             IF LEFT$(Buf, 1) = CHR$(0) THEN
                Buf = UCASE$(RIGHT$(Buf, 1))
                IF Buf = "P" AND j < 7 THEN
                j = j + 1
                ELSEIF Buf = "H" AND j > 0 THEN
                j = j - 1
                ELSEIF Buf = "K" AND i > 0 THEN
                i = i - 1
                ELSEIF Buf = "M" AND i < 14 THEN
                i = i + 1
                END IF
             ELSE
             Buf = UCASE$(RIGHT$(Buf, 1))
             IF Buf = "" THEN k = 0 ELSE k = ASC(Buf)
             IF Buf = "S" THEN
                SaveFile
             ELSEIF Buf = "Z" THEN
                DefineAsc
             ELSEIF Buf = "W" THEN
                WinTerminated = TRUE
             ELSEIF Buf = "X" THEN
                WinTerminated = TRUE
                Terminated = TRUE
             ELSEIF Buf = "Y" THEN
                xnd = xn: ynd = yn: xd = i: yd = j
             ELSEIF Buf = "T" THEN
                OPEN "DATA.DAT" FOR OUTPUT AS #1
                  PRINT #1, MaxZ
                  FOR x = 0 TO MaxZ
                     PRINT #1, Pz(x)
                     PRINT #1, Tz(x)
                  NEXT
                CLOSE #1
                LOCATE 24, 1: PRINT "Data saved!";
             ELSEIF k >= ASC("A") AND k <= ASC("A") + MaxZ THEN
                p(xn, yn, i, j) = CHR$(Pz(k - ASC("A")))
                t(xn, yn, i, j) = CHR$(Tz(k - ASC("A")))
             END IF
             END IF
        WEND
    WEND

' Fin du programme

' Donnes
Graphique:
DATA "Bloc","BlocSup","CroixSu",CroixVer","Tapisser","Brique"
DATA "Pont","PlateFo","Pic","Araigne","Cactus","Bijou","1-up","Porte"
DATA "Clef","Tronc","Arbre","Buisson","Fleur","Bumper","Fond","Turbo","Croix"
DATA "Machine","Herbe","Rocher","Colonne","Nuage","Rond HG","Rond HD","Rond BG","Rond BD"
DATA "Montagne","Cascade","Fleuremp","TapisCroix","Man","TapisG","TapisD"
DATA "Champign","MrPierre","END"
DATA "Bloc","Platef","Monte","Bijou","1-up","Bumper","Clef","Porte"
DATA "Pic","Haut","Bas","Gauche","Droite","Arrive","SpriteH","SpriteV","END"

SUB Affichage

DIM i1 AS INTEGER
DIM j1 AS INTEGER


FOR j1 = 0 TO 7
    FOR i1 = 0 TO 14
        COLOR 2
        LOCATE j1 + 1, i1 + 1
        IF ASC(p(xn, yn, i1, j1)) > 0 THEN
                PRINT CHR$(ASC(p(xn, yn, i1, j1)) + 48);
        ELSE
                PRINT " ";
        END IF
        COLOR 9
        LOCATE j1 + 1, i1 + 41
        IF ASC(t(xn, yn, i1, j1)) > 0 THEN
                PRINT CHR$(ASC(t(xn, yn, i1, j1)) + 48);
        ELSE
                PRINT " ";
        END IF
    NEXT
NEXT

COLOR 12
LOCATE j + 1, i + 1
PRINT "*";
LOCATE j + 1, i + 41
PRINT "*";
COLOR 15

END SUB

SUB ClearFile
                FOR yn = 0 TO Maxy
                 FOR xn = 0 TO Maxx
                  FOR j = 0 TO 7
                   FOR i = 0 TO 14
                    p(xn, yn, i, j) = CHR$(0)
                    t(xn, yn, i, j) = CHR$(0)
                   NEXT
                  NEXT
                 NEXT
                NEXT

OPEN FileName FOR OUTPUT AS #1
CLOSE

END SUB

SUB DefineAsc

DIM i1 AS STRING
DIM i2 AS INTEGER

PrintScreen
        LOCATE 4, 1
        FOR k1 = 0 TO MaxTest
            PRINT "  "; CHR$(k1 + 49); "  :: "; Test(k1);
        NEXT
i2 = -1
WHILE i2 < 0 OR i2 > MaxZ
        LOCATE 1, 1: INPUT "No ou lettre  modifier:"; i1
        IF i1 <> "" THEN i2 = ASC(UCASE$(i1)) - ASC("A")
WEND

LOCATE 2, 1: INPUT "Picture:"; i1
Pz(i2) = ASC(i1) - 48

LOCATE 3, 1: INPUT "Test   :"; i1
Tz(i2) = ASC(i1) - 48

PrintScreen
       

END SUB

SUB OpenFile
       
        OPEN FileName FOR BINARY AS #1
                k = 1
                GET #1, k, Cla: xnd = ASC(Cla)
                k = 2
                GET #1, k, Cla: ynd = ASC(Cla)
                k = 3
                GET #1, k, Cla: xd = ASC(Cla)
                k = 4
                GET #1, k, Cla: yd = ASC(Cla)
                k = 5
                FOR yn = 0 TO Maxy
                 FOR xn = 0 TO Maxx
                  FOR j = 0 TO 7
                   FOR i = 0 TO 14
                    GET #1, k, Cla
                    p(xn, yn, i, j) = Cla
                    k = k + 1
                   NEXT
                  NEXT
                  FOR j = 0 TO 7
                   FOR i = 0 TO 14
                    GET #1, k, Cla
                    t(xn, yn, i, j) = Cla
                    k = k + 1
                   NEXT
                  NEXT
                 NEXT
                NEXT
        CLOSE #1

END SUB

SUB PrintScreen

DIM k1 AS INTEGER
       
        CLS

        LOCATE 9, 1
        PRINT "Picture"
     
        LOCATE 9, 41
        PRINT "TEST"

        LOCATE 10, 1
        FOR k1 = 0 TO MaxDessin
            PRINT "  "; CHR$(k1 + 49); "  -> "; Dessin(k1);
        NEXT
       
        LOCATE 19, 1
        PRINT "S save T SaveGraph Z define Y dpart W end X exit"
        PRINT " Dpart : "; xnd; ynd; " en "; xd; yd; " Case :"; xn; yn

        LOCATE 21, 1: PRINT "No";
        LOCATE 22, 1: PRINT "Dessin";
        LOCATE 23, 1: PRINT "Test";

        FOR k = 0 TO MaxZ
                LOCATE 21, 3 * k + 10: PRINT CHR$(k + ASC("A"));
                LOCATE 22, 3 * k + 10: PRINT CHR$(Pz(k) + 48);
                LOCATE 23, 3 * k + 10: PRINT CHR$(Tz(k) + 48);
        NEXT
              

END SUB

SUB SaveFile
  
    KILL FileName

    OPEN FileName FOR BINARY AS #1
                k = 1
                Cla = CHR$(xnd): PUT #1, k, Cla
                k = 2
                Cla = CHR$(ynd): PUT #1, k, Cla
                k = 3
                Cla = CHR$(xd): PUT #1, k, Cla
                k = 4
                Cla = CHR$(yd): PUT #1, k, Cla
                k = 5
                FOR m = 0 TO Maxy
                 FOR n = 0 TO Maxx
                  FOR j = 0 TO 7
                   FOR i = 0 TO 14
                    Cla = p(n, m, i, j)
                    PUT #1, k, Cla
                    k = k + 1
                   NEXT
                  NEXT
                  FOR j = 0 TO 7
                   FOR i = 0 TO 14
                    Cla = t(n, m, i, j)
                    PUT #1, k, Cla
                    k = k + 1
                   NEXT
                  NEXT
                 NEXT
                NEXT
        CLOSE #1


END SUB

