EXTENDED_SPRITE		EQU	(2*SpriteInitStart+86)


Sprite_Init_Pow:
	move.w	#EXTENDED_SPRITE,No(a1)
	moveq	#8,d0
	add.w	d0,d1
	add.w	d0,d2
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	#38,POW_TMP(a1)
	lea	POW_END(a1),a1
	rts

Sprite_Init_Spider:
	move.w	#EXTENDED_SPRITE+2,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	d3,Adresse(a1)
	clr.w	SPIDER_ACT(a1)
	move.w	#10,FORCE(a1)
	move.w	Turbo(a6),SPIDER_V(a1)
	move.l	SpriteADR(a6),a0
	cmp.w	Xj(a0),d1
	blt.s	\Ok
	neg.w	SPIDER_V(a1)
\Ok:	lea	SPIDER_END(a1),a1
	rts

Sprite_Init_Ber:
	move.w	#EXTENDED_SPRITE+4,No(a1)
	addq.w	#7,d1
	add.w	#16,d2
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	d3,Adresse(a1)
	clr.w	BER_TMP(a1)
	move.w	#20,FORCE(a1)
	lea	BER_END(a1),a1
	rts

Sprite_Init_Butter_Fly:
	move.w	#EXTENDED_SPRITE+6,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	d3,Adresse(a1)
	moveq	#30,d0
	move.w	d0,DEST_X(a1)
	move.w	d0,DEST_Y(a1)
	move.w	d0,FORCE(a1)
	move.w	d0,BUT_TMP(a1)
	lea	BUT_END(a1),a1
	rts

Sprite_Init_Nibbles:
	move.w	#EXTENDED_SPRITE+8,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	d3,Adresse(a1)
	moveq	#50,d0
	move.w	d0,DEST_X(a1)
	move.w	d0,DEST_Y(a1)
	move.w	d0,FORCE(a1)
	move.w	d0,BUT_TMP(a1)
	clr.w	NIB_D(a1)
	lea	NIB_TABLE(a1),a0
	moveq	#SIZE_NIBBLES-1,d0
\l1:	move.w	d1,(a0)+
	move.w	d2,(a0)+
	dbf	d0,\l1
	lea	NIB_END(a1),a1
	rts

Sprite_Init_PacMan:
	move.w	#EXTENDED_SPRITE+10,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	lea	PAC_END(a1),a1
	rts

Sprite_Init_Boum:
	move.w	#EXTENDED_SPRITE+12,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	addq.l	#BOUM_END,a1
	rts

Sprite_Init_Plane:
	move.w	#EXTENDED_SPRITE+14,No(a1)
	move.w	d1,Xj(a1)
	move.w	d2,Yj(a1)
	move.w	d3,Adresse(a1)
	move.w	#1,PLANE_SENS(a1)
	move.l	SpriteADR(a6),a0
	cmp.w	Xj(a0),d1
	blt.s	\Ok
	neg.w	PLANE_SENS(a1)
\Ok:	moveq	#20,d0
	move.w	d0,PLANE_TMP(a1)
	move.w	d0,FORCE(a1)
	lea	PLANE_END(a1),a1
	rts
