;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
; *****************************************************************
; ***								***
; ***	               COOPERATION MODE				***
; ***								***
; *****************************************************************
; *****************************************************************

Select_Player:
	WriteStr	#PLAYER_X,#PLAYER_Y,#4,Player_Menu_Str
	bsr	GetKey
	cmp.w	#264,d0
	bne.s	No_Esc
Exit_Select_Player:
	moveq	#1,d0
	rts
No_Esc:	cmp.w	#268,d0
	bcs.s	Select_Player
	bne.s	\NoF1
	clr.w	NbrJoueur(a6)
	rts
\NoF1:
	cmp.w #(267+MAX_PLAYER),d0
	bhi.s	Select_Player
	sub.w	#268,d0
	move.w	d0,NbrJoueur(a6)
	move.w	d0,d5
	move.l	SpriteADR(a6),a5
Loop_Search_Key:
	WriteStr	#PLAYER2_X,#PLAYER2_Y,#4,Player_Str
	move.w	d5,d3
	addq.w	#1,d3
	move.w	#PLAYER2_Y,d2
	bsr	PutNumber
	WriteStr	#PLAYER3_X,#PLAYER3_Y,#4,Keyboard_Str
	moveq	#4,d3
\Sub_Loop:
	bsr	GetKey
	cmp.w	#264,d0
	beq.s	Exit_Select_Player
	bsr	GetKeyStat
	moveq	#Row_Key,d0
\Sub2_Loop:
	moveq	#7,d1
\Sub3_Loop:
	btst.b	d1,keystat(PC,d0.w)
	beq.s	\Find_A_Key
	dbf.s	d1,\Sub3_Loop
	dbf.s	d0,\Sub2_Loop
	bra.s	\Sub_Loop
\Find_A_Key:
	move.w	d3,d2
	add.w	d2,d2		; d2 = 2 * d3
	move.b	d1,F_End(a5,d2.w)
	move.b	d0,(F_End+1)(a5,d2.w)
	dbf.s	d3,\Sub_Loop
	lea	F_Multi_End(a5),a5
	dbf.s	d5,Loop_Search_Key
	moveq	#0,d0
	rts

; Keystat is here because  I need to access like that : keystat(PC,d0.w)
; in Select_Player and Sprite_Fernando_Multi
fer3c@0010:
keystat		ds.b	10

Sprite_Fernando_Multi:
	move.w	keystat(Pc),-(a7)	; Save keys
	move.w	Bj(a6),-(a7)		; Save power
	move.w	F_Power(a5),Bj(a6)	; Set power

	moveq	#-1,d4
	clr.w	d0		; D0.l isn't cleared
	move.b	Up(a5),d1
	move.b	(Up+1)(a5),d0
	btst.b	d1,keystat(PC,d0.w)
	bne.s	\NoUp
	bclr.b	#Up_Key,d4
\NoUp:
	move.b	Down(a5),d1
	move.b	(Down+1)(a5),d0
	btst.b	d1,keystat(PC,d0.w)
	bne.s	\NoDown
	bclr.b	#Down_Key,d4
\NoDown:
	move.b	Left(a5),d1
	move.b	(Left+1)(a5),d0
	btst.b	d1,keystat(PC,d0.w)
	bne.s	\NoLeft
	bclr.b	#Left_Key,d4
\NoLeft:
	move.b	Right(a5),d1
	move.b	(Right+1)(a5),d0
	btst.b	d1,keystat(PC,d0.w)
	bne.s	\NoRight
	bclr.b	#Right_Key,d4
\NoRight:
	move.b	Jump(a5),d1
	move.b	(Jump+1)(a5),d0
	btst.b	d1,keystat(PC,d0.w)
	bne.s	\NoJump
	bclr.b	#Jump_Key,d4
\NoJump:
	move.b	d4,keystat
	bsr	Sprite_Fernando
	move.w	Bj(a6),(F_Power-F_End)(a5)	; Get power
	move.w	(a7)+,Bj(a6)		; Restore power
	move.w	(a7)+,(keystat-fer3c@0001)(a6)	; Restore keys
	lea	(F_Multi_End-F_End)(a5),a5	; Next sprite
	rts

Sprite_Gestion_Multi:
	movem.l	d0-d4/a0-a6,-(a7)

; Rotation des fernandos en premire place
	move.w	TailleGest(a5),d7
	move.w	G_Power(a5),d0
	move.w	Bj(a6),d1
	move.l	a5,-(a7)		; Save current position of a5 on the stack

	move.l	SpriteADR(a6),a5
	add.w	d1,F_Power(a5)	; Save the power of the Fer
	sub.w	d0,F_Power(a5)	; Correction
	move.l	a5,a3
	move.l	a5,a4			; Save a5:SpriteADR
	movem.l	(a5)+,d0-d6/a0-a2	; Load First Fernando Multi : 40 Bytes
\Loop:
	move.l	(a5)+,(a4)+
	dbf.s	d7,\Loop
	movem.l	d0-d6/a0-a2,-(a5)	; Push First Fernando in the Last place
					; Initialisation du Fernando qui va se 
					; manger les tests de sprite
	move.l	a3,a5			; a5 pointe  nouveau  SpriteADR
	move.w	Xj(a5),d6		; Init X_Fernando
	move.w	Yj(a5),d7		; Init Y_Fernando
	move.w	F_Power(a5),Bj(a6)	; Init power
	move.w	F_Power(a5),d0		; Save power in multi-player

	move.l	(a7)+,a0		; Rescover some data
	move.w	d0,G_Power(a0)		; Save new value of G_Power

; Calcul du pointeur de scrolling
	moveq	#0,d0
	moveq	#0,d1
	move.w	NbrJoueur(a6),d2
\Loop2:
	add.w	Xj(a5),d0
	add.w	Yj(a5),d1
	lea	F_Multi_End(a5),a5
	dbf.s	d2,\Loop2
	move.w	NbrJoueur(a6),d2
	addq.w	#1,d2
	divu.w	d2,d0
	divu.w	d2,d1
	bsr	UpDateScrollVar

; Touche de recentrage alatoire
	ReCenter_Key_Test
	bne.s	\No
	move.w	Xj(a3),d0
	move.w	Yj(a3),d1
 	bra.s	\ReCenter
\No
; Verification s'il y a tlportation ?
	cmp.b	#TELEPORTATION,Mort(a6)
	bne.s	\NoNewStart
	move.w	StartX(a6),d0
	move.w	StartY(a6),d1
\ReCenter:
	move.w	NbrJoueur(a6),d2	; a3 pointe vers la liste-pile de sprites
\Starting_Loop:
	move.w	d0,Xj(a3)
	move.w	d1,Yj(a3)
	lea	F_Multi_End(a3),a3
	dbf.s	d2,\Starting_Loop
\NoNewStart:
	movem.l	(a7)+,d0-d4/a0-a6
	lea	Gest_Multi_End(a5),a5
	rts

Init_Fernando:
	move.w	NbrJoueur(a6),d3
	bne.s	\Multi
	moveq	#0,d0
	bra	SpriteInit	; Init Fernando Solo and back	
\Multi:
	moveq	#16,d0		; Init Fernando Multi-Player
	bsr	SpriteInit
	dbf.s	d3,\Multi
	moveq	#18,d0		; Init Gest Multi-Fernando and back
	bra	SpriteInit

